<?php

class BsmsPullDelivery {
	
	private $username;
	private $password;
	private $deliveries = array();
	
	function __construct($username, $password) {
		$this->username = $username;
		$this->password = $password;
	}
	
	function addDelivery($id) {
		$this->deliveries[$id] = array(
			'id' => $id,
		);
	}
	
	function send() {
		$url = 'http://api.bsms.viamobile.sk/json/delivery';
		
		$data = array();
		$data['username'] = $this->username;
		$data['password'] = $this->password;

		$data['deliveries'] = $this->deliveries;
		$json = json_encode($data);

		///-------------------------------------------------------------
		// HTTP POST
		$options = array(
			'http' => array(
				'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
				'method'  => 'POST',
				'content' => $json,
				'ignore_errors' => TRUE
			),
		);
		$context  = stream_context_create($options);
		$result = @file_get_contents($url, false, $context);

		
		if($result === false) {
			throw new RuntimeException("HTTP POST request failed");
		}
		
		$result = json_decode($result, true);
		if($result === false) {
			throw new RuntimeException("Response is not valid JSON");
		}
		
		
		if($result['response']['status'] != '200') {
			throw new RuntimeException("Exception occured. Error code=" . $result['response']['code'] . ', message=' . $result['response']['description']);
		} 
		
		return $result['response']['delivery'];
	}
}
