<?php

class BsmsSender {
	
	private $username;
	private $password;
	private $sender;
	private $type;
	private $mtSms = array();
	
	function __construct($username, $password, $sender, $type = 'gsm') {
		$this->username = $username;
		$this->password = $password;
		$this->sender = $sender;
		$this->type = $type;
	}
	
	function addSms($id, $msisdn, $message) {
		$this->mtSms[$id] = array(
			'id' => $id, 
			'msisdn' => $msisdn, 
			'text' => $message, 
		);
	}
	
	function send() {
		$url = 'http://api.bsms.viamobile.sk/json/send';
		
		$data = array();
		$data['username'] = $this->username;
		$data['password'] = $this->password;
		
		$data['message'] = array(
			'sender' => $this->sender,
			'message' => '',
			'type' => $this->type,
		);
		$data['recipients'] = $this->mtSms;
		$json = json_encode($data);

		///-------------------------------------------------------------
		// HTTP POST
		$options = array(
			'http' => array(
				'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
				'method'  => 'POST',
				'content' => $json,
				'ignore_errors' => TRUE
			),
		);
		$context  = stream_context_create($options);
		$result = @file_get_contents($url, false, $context);

		
		if($result === false) {
			throw new RuntimeException("HTTP POST request failed");
		}
		
		$result = json_decode($result, true);
		if($result === false) {
			throw new RuntimeException("Response is not valid JSON");
		}
		
		
		if($result['response']['status'] != '200') {
			throw new RuntimeException("Exception occured. Error code=" . $result['response']['code'] . ', message=' . $result['response']['description']);
		} 
		
		return $result['response']['recipients'];
	}
}
